/*	FUNZIONI DI UTILITA` GENERALE PER L'INTERFACCIA DEI SOCKET
        VERSIONE PER UNIX BSD4.3
*/


#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>


void err_fatal(char *mes);
void SockStartup(void);
void SockCleanup(void);
void showAddr(char * str, struct sockaddr_in * a);

/* Error handling function for fatal errors */
void err_fatal(char *mes)
{
	printf("%s, errno=%d\n", mes, errno);
	perror("");
	exit(1);
}

/* Error handling function for nonfatal errors */
void err_continue(char *mes)
{
	printf("%s, errno=%d\n", mes, errno);
	perror("");
}

/* BSD4.3 Sockets Api: Initialization function */
void SockStartup(void)
{
	/* don't need initialization */
        return;
}

/* BSD4.3 Sockets Api: Cleanup function */
void SockCleanup(void)
{
        /* don't need cleanup */
        return;
}

/* Funzione per visualizzare una stringa e un indirizzo di rete */
void showAddr(char *str, struct sockaddr_in *a)
{
	unsigned int ipaddr;
        unsigned char *p;

	ipaddr = a->sin_addr.s_addr;
	p = (unsigned char *) &ipaddr;
	printf("%s ",str);
	printf("%03d.", p[0] );
	printf("%03d.", p[1] );
	printf("%03d.", p[2] );
	printf("%03d!", p[3] );
	printf("%u\n", ntohs(a->sin_port));
}
